Bug 847458 - Saving in Vimdot can crash the graphical window
Saving in Vimdot can crash the graphical window
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: graphviz (Show other bugs)
23
Unspecified Unspecified
unspecified Severity high
: ---
: ---
Assigned To: Jaroslav Škarvada
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-11 13:10 EDT by Volker Fröhlich
Modified: 2016-12-20 07:17 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 07:17:17 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Volker Fröhlich 2012-08-11 13:10:05 EDT
vimdot can crash when saving your changes.

Version-Release number of selected component (if applicable):

F16: 2.28.0-11, F17: 2.28.0-15

How reproducible:

1. Create a simple file using vimdot with content like this:

graph{
    layout=neato
    one -- two 
    one -- three
    two -- three
}

Alternatively create the file with a different editor and just open it with vimdot.

2. Using vimdot, change layout between neato, circo and twopi. Always save after the change.

3. Witness either a segfault, the window disappear or getting some stderr thrown in

It seems to be not reproduceable every time. There are various other changes you can do in vimdot to crash it, when saving.

I tried the same with Ubuntu 12.04, that ships 2.26.3  and I couldn't crash it like that.
Comment 1 Volker Fröhlich 2012-11-22 07:52:25 EST
Can I provide something else?
Comment 2 John Ellson 2012-11-22 16:54:08 EST
You could try a recent snapshot from upstream - http://www.graphviz.org/

Worked for me.

We should have a new release available soon.
Comment 3 Volker Fröhlich 2012-11-23 15:56:24 EST
I just crashed the latest snapshot. It took like 5 changes to the layout setting. I used the Fedora spec file and just updated sources to build it. If you think this is not specific to Fedora builds, I'll continue upstream.
Comment 4 John Ellson 2012-11-24 23:27:37 EST
I can reproduce the crash, but not with reproducible results under gdb  ..,  this is going to be a tough one.

BTW.  To eliminate vim, I'm using this shell script to generate a changing graph:

#!/usr/bin/bash
delay=4
while true; do
  echo "graph { layout=dot; one -- two -- three -- one }" >test.gv
  sleep $delay
  echo "graph { layout=dot; one -- two -- three -- four -- one }" >test.gv
  sleep $delay
done


Then using:
$ gdb dot
(gdb) run -Txlib test.gv
Comment 5 Fedora End Of Life 2013-04-03 11:18:15 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 6 Volker Fröhlich 2013-05-08 03:30:55 EDT
Still present in 2.30, at least when rebuilt on F18. I think I still haven't filed the issue upstream.
Comment 7 Fedora Admin XMLRPC Client 2013-08-16 00:43:55 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 8 Fedora Admin XMLRPC Client 2013-09-02 09:38:06 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 9 John Ellson 2013-09-04 22:08:56 EDT
Finally, I think I've fixed this -- should be in graphviz-2.34 to be released in a day or so.  (Improper cgraph initialization in lib/gvc/gvevent.c)
Comment 10 Volker Fröhlich 2013-09-13 17:31:15 EDT
I'm looking forward to testing it!
Comment 11 Jaroslav Škarvada 2013-09-16 06:49:01 EDT
It seems to work for me with graphviz-2.34, feel free to comment or reopen if you can still reproduce the crash.
Comment 12 Volker Fröhlich 2013-09-16 13:03:14 EDT
I rebuilt 2.34 for F18.

I'm afraid only half the issue is solved yet. While I couldn't crash vimdot switching between different layouts, entering something invalid for "layout" immediately did.
Comment 13 John Ellson 2013-09-17 09:28:50 EDT
Mmm, this may not be easy to fix....   vimdot was written as a quick hack to test the inotify mechanism for detecting updates to input files.  Error handling was apparently not well thought out.

In this case, an error in the input file (the saved output from vim) is detected and reported to stderr, and at that point there isn't a valid graph to display.

I agree that from a usability standpoint this is not very good.   It should be possible to recover from input errors without losing the Window.


I can look at treating all (most?) errors as a trivial graph with a label containing the error message .....  not sure when I'll get to this...
Comment 14 Jan Kurik 2015-07-15 11:04:39 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23
Comment 15 Fedora End Of Life 2016-11-24 05:43:17 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 16 Fedora End Of Life 2016-12-20 07:17:17 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.